;========================================================
;GENERAL DATA
;========================================================
;(lots of wasted spaced, but the file's not huge anyhow)

StringBuffer	    db	    512 dup 0	  ;storage for EXE name and root Trespasser folder (faster if static)
PathStringSize	    dd	    0
MapsDirBuffer	    db	    512 dup 0	  ;root Trespasser folder + 'MAPS\' subfolder
MapsPathSize	    dd	    0
DDF_FN_Buffer	    db	    512 dup 0	  ;used for DDF (same as MapsDirBuffer)
ATXconfiginiFN	    db	    512 dup 0	  ;full ATXconfig.ini filename and path

_integer	    dd	    "%i",0	  ;for MSVCRT calls (if present)
_float		    dd	    "%f",0
_unint		    dd	    "%u",0

WindowName	    db	    "Trespasser",0
WindowClassName     db	    "DWI - Trespasser",0
ATXCONFIGFN	    db	    "ATXconfig.ini",0

SAVEGAMENAME_STR    db	    "SAVEGAME.%.3u",0

ATX_title_main	    db	    "ATX Exit Error",0
ATX_rv_warning	    db	    "Warning! Video recording halted prematurely.",0Dh,0Ah
		    db	    "Please restart your computer.",0

system_info_buf     SYSTEM_INFO
find_data_buf	    FINDDATA
stack_ext_buffer    db	    600 dup 0	    ;may be used instead of large amounts of local
					    ;stack variables, to prevent stack overflows
					    ;(may be referred to from high address as standard stack
					    ; or from low address as buffer, depending on procedures)


GetTickCount	    dd	     GetTickCountINGAME
LevelStart_TICK     dd	     0

VirtualProtectEx		dd	 0
UseOldVirtualProtectFunction	dd	 0

;========================================================
include 'Errors.inc'
;========================================================

DEFAULT_FOG_COLOR_VALUE     dd	    0
DisableInGameMouseMvt	    db	    FALSE
CAnimalBuffer		    dd	    0		  ;holds pointers to all CAnimal objects and all CAnimal ATX info
CAnimalBufferEnd	    dd	    0		  ;always valid and non-zero when CAnimalBuffer is not null
CAnimalBufferSize	    dd	    0		  ;always valid and non-zero when CAnimalBuffer is not null
CAnimal_JUMP_Info_BUF	    dd	    0
CAnimal_Intance_Count	    dd	    0

Restart_Exit_Level_BOOL     db	    0
TempMessageTime 	    dd	    0
TempMessageString	    dd	    0
TempMessageParam1	    dd	    0
TempMessageParam2	    dd	    0
TempMessageParam3	    dd	    0
TempMessageParam4	    dd	    0

;========================================================
;DirectDraw data
;========================================================
PrimarySurfaceDC	dd	0
PrimarySurfaceObj	dd	0
Effects_BOOL		dd	0	;bit0 = effect1, bit1 = n/a

lpDDBltFx		DDBLTFX
;DDSurface_Temp          DDSURFACEDESC2

;========================================================
;instance location randomization values
;========================================================
NULL_STRING		db	"NULL",0
ZERO_STRING		db	"0",0
FLOAT_RETRIEVE_STRING	db	"%f, %f, %f",0
MAIN_SECTION		db	"Instances",0
ENTRIES_STRING		db	"Entries",0
ENTRY_COUNT		db	"NumberOfENTRYSections",0
INSTANCE_STRING 	db	"Instance%u",0
RESERVE_STRING		db	"Reserve%u",0
ENTRY_STRING		db	"ENTRY%u",0
LOCATION_STRING 	db	"Location%u",0
STAYNEARMAX_STRING	db	"ForceStayNearMax",0
STAYNEAROK_STRING	db	"ForceStayNearOK",0
WAKEUP_STRING		db	"ForceWakeUp",0
SLEEP_STRING		db	"ForceSleep",0
NOGETOUT_STRING 	db	"DisableActGetOut",0

;buffers used during initialization (unfortunately, cannot be in local
;memory due to stack overflows or such)
RAND_BUF1		db	200 dup 0
RAND_RSRV_ENTRY_BUF	db	200 dup 0
RAND_INST_NAME_BUF	db	200 dup 0
RAND_LOC_STR_BUF	db	200 dup 0

;========================================================
;CANIMAL cheat data
;========================================================
canimal_title_base	db	"CAnimal Info (%u instances):",0
canimal_title_size	dd	0
canimal_title		db	55 dup 0
canimal_base_addr	db	"Base Address: 0x%.8X",0
canimal_pos		db	"Location: %.2f, %.2f, %.2f",0
canimal_health		db	"HitPoints: %.2f",0
canimal_maxhealth	db	"MaxHitPoints: %.2f",0
canimal_bravery 	db	"Bravery: %.5f",0
canimal_jumpinfo	db	"ActJumpNew info: %.2f, %.2f, %u, %u, %u",0
canimal_sleepwakeup	db	"Sleep & WakeUp: %.5f, %.5f",0

canimal_emos_text_table:
	dd canimal_fear,canimal_love,canimal_anger,canimal_curiosity
	dd canimal_hunger,canimal_thirst,canimal_fatigue,canimal_pain
canimal_emos_text_table_end:

canimal_emos_offsets_table:	   ;offsets from main AI class
	dd 4h,8h,0Ch,10h
	dd 14h,18h,1Ch,20h

canimal_anger		db	"Anger: %.5f",0
canimal_curiosity	db	"Curiosity: %.5f",0
canimal_fatigue 	db	"Fatigue: %.5f",0
canimal_fear		db	"Fear: %.5f",0
canimal_hunger		db	"Hunger: %.5f",0
canimal_love		db	"Love: %.5f",0
canimal_thirst		db	"Thirst: %.5f",0
canimal_pain		db	"Pain: %.5f",0

DisplayDinoInfo_BOOL	db	0
DisplayDino_INDEX	dd	0
ShowPlayerHealth_BOOL	db	0

ShowDinosOnMap_BOOL		db	0
ShowActiveDinoOnMap_BOOL	db	0

ShowFaceFloats_BOOL		db	0
ShowFaceFloat_STRING		db	"Player face values (wxyz): %.3f, %.3f, %.3f, %.3f",0
ShowFaceFloat_AA_STRING 	db	"Angle (rad) & Axis (xyz): %.3f, %.3f, %.3f, %.3f",0
ShowPlayerHealth_STRING 	db	"Player HitPoints & MaxHitPoints: %.5f, %.5f",0

;========================================================
;other
;========================================================


;FLAGS/VALUES
UseWINDOWED		    dd	    0
UseGRAVITY		    dd	    0
UseDRAWDISTANCE 	    dd	    0
UseTRESSTRDBG		    dd	    0
UseDEMOHACK		    dd	    0
UseNoGetOut		    dd	    0
UseNoStayNear		    dd	    0
UseNoStayAway		    dd	    0
UseSleepWake		    dd	    0
UseDisableSWPDelete	    dd	    0
UseCAnimalHitPoints	    dd	    0
UseRandomInstanceLocations  dd	    0
UseDisableActJumpNew	    dd	    0
UseDisableQuadrupedJumps    dd	    0

UseUserMapKey		    dd	    0
UseUserMDinoKey 	    dd	    0
UseDrawDistSubKey	    dd	    0
UseDrawDistAddKey	    dd	    0
UseCANIMALKey		    dd	    0
UseUserMSelKey		    dd	    0
UseUserCANIMALLEFTKey	    dd	    0
UseUserCANIMALRIGHTKey	    dd	    0
UseMXTRadius		    dd	    0
MXTRadiusEXP2		    dd	    0

UseToggleNewKeys	    dd	    0
ToggleNewKeys_BOOL	    db	    1
ToggleKeys_FORCED_BOOL	    db	    0
ToggleKeysShowStateTime     dd	    0

;troubleshooting
UseDisableA3Ddll	    dd	    0
UseHighResolutionsHack	    dd	    0

SDBGDUMPFILE		    db	    "C:\SDBG_DUMP.txt",0

RT_ERROR_COUNT		    dd	    0
LAST_ERROR_TIME 	    dd	    0
ErrorCountDisplayString     db	    "ATXTres Error Detected (Total: %u)",0

FPS_framecount		    dd	    0
FPS_lastframetime	    dd	    0
FPS_toggle		    db	    0
FPS_string		    db	    "FPS: %.2f",0
FPS_lastfps		    dq	    0

;========================================================
;VARIOUS STORED FLOATS
;========================================================

align 4
float_0 		dd	0.000000
float_two		dd	2.000000
			dd	2.000000
float_one		dd	1.000000
float_minusone		dd	-1.000000
float_0_5		dd	0.500000
float_0_5_B		dd	0.500000
float_5 		dd	5.000000
pidivtwo		dd	1.5707963267948966192313216916398
pi			dd	3.1415926535897932384626433832795
pi2			dd	6.28318530717958647692528676655901
minuspi2		dd	-6.28318530717958647692528676655901
pidiv180		dd	0.0174532925199432957692369076848861
d180divpi		dd	57.2957795130823208767981548141052
float_100		dd	100.000000
float_15		dd	15.000000
float_1000		dd	1000.000000
float_0_001		dd	0.001000
float_0_0005		dd	0.0005
float_1div255		dd	0.00392156862745098039215686274509804

;========================================================
;MAP cheat data
;========================================================
MapIndex		    db	    "MapIndex.ini",0
STRING_Bitmap		    db	    "Bitmap",0
STRING_BMPDEF		    db	    "DEF",0
STRING_X1		    db	    "X1",0
STRING_Y1		    db	    "Y1",0
STRING_X2		    db	    "X2",0
STRING_Y2		    db	    "Y2",0
BMPMAPNAME_BUF		    db	    150 dup 0
MapLoadSuccess_BOOL	    db	    FALSE

;========================================================
;ActionType data
;========================================================

;AT102
AT102EMULATEDOBJECT:
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    1	;1 for direct BMP name ref (not relative to buffer)

;current bitmap values /*
anchorXvalue	    dd	    0
anchorYvalue	    dd	    0
scaleXvalue	    dd	    0
scaleYvalue	    dd	    0

currentbitmap	    dd	    0
bitmapheight	    dd	    0
bitmapwidth	    dd	    0
;                       */

USE_MAP 	    db	    0
USE_LOC 	    db	    0
LastTickCount	    dd	    0
Show_Blinker	    db	    1

SAVED_MAP_BUFFER    db	    80 dup 0
		    db	    0		;"insurance" null-terminator
CURRENT_MAP_BUFFER  db	    80 dup 0
		    db	    0		;"insurance" null-terminator
CURRENT_MAP_VALUES  dd	    4 dup 0

SAVEGAMENAME_BUFFER  db     256 dup 0

SAVED_MAP_OBJECT:
		    dd	    0
		    dd	    0
		    dd	    SAVED_MAP_BUFFER
SAVED_MAP_X1	    dd	    0
SAVED_MAP_Y1	    dd	    0
SAVED_MAP_X2	    dd	    0
SAVED_MAP_Y2	    dd	    0
		    dd	    1		;1 for direct BMP name ref

IsInGame_BOOL			db	0
IsInConsole_BOOL		db	0
NotInGame_BOOL			db	0
NotInGameStart_TICK		dd	0
NotInGameEnd_TICK		dd	0
NotInGame_TOTALMENUTIME 	dd	0

DrawDistDisplayTime		dd	0
DrawDistDisplayString		db	"Draw Distance: %2f",0

AT19EMULATEDOBJECT:	  ;36 bytes (basically same as AT16 class)
		dd	 0	;VTable
		dd	 0	;RefCount
		dd	 0	;name string length
		dd	 010h	;???
		dd	 4 dup 0    ;storage for names shorter than 16 bytes
		dd	 0	;pointer to name string (to previous buffer if less than 16 bytes)

;========================================================
;counter data
;========================================================
CounterFirstRun     dd	    0
USE_COUNTER	    dd	    0
FirstTimeStamp	    dd	    0
Time_Format_String  db	    "Time: %.2u:%.2u:%.2u",0


;========================================================
;HACKED CONSOLE VARIABLES
;========================================================

STRING_LOC		    db	"LOC",0
STRING_DINOS		    db	"DINOS",0
STRING_BIONICWOMAN	    db	"BIONICWOMAN",0
STRING_INVUL		    db	"INVUL",0
STRING_WOO		    db	"WOO",0

Cheattable:
       times ((EndNewCheattableMembers-NewCheattableMembers)+DEFAULT_CHEAT_ENTRY_COUNT*8) db 0

STRING_MAP		    db	"MAP",0
STRING_TIME		    db	"TIME",0
STRING_RESET		    db	"RESET",0
STRING_DINOINFO 	    db	"CANIMAL",0
STRING_DINOINFOCYCLELEFT    db	"B",0
STRING_DINOINFOCYCLERIGHT   db	"N",0
STRING_KILLDINO 	    db	"KILL",0
STRING_MDINO		    db	"MDINO",0
STRING_MSEL		    db	"MSEL",0
STRING_HEALDINO 	    db	"HEALDINO",0
STRING_TESTCHEAT	    db	"TEST",0
STRING_CLOAK		    db	"CLOAK",0
STRING_FAC		    db	"FAC",0
STRING_FLY		    db	"FLY",0
STRING_KILLALL		    db	"KILLALL",0
STRING_TELEDINO 	    db	"TELEDINO",0
STRING_REC		    db	"REC",0
STRING_PLAYERHEALTH	    db	"PLAYERHEALTH",0
STRING_FPS		    db	"FPS",0
STRING_SUPERHP		    db	"SUPERHP",0
STRING_NORMALHP 	    db	"NORMALHP",0
STRING_SHOWDD		    db	"SHOWDD",0
STRING_DRV		    db	"DRV",0
STRING_LOAD		    db	"LOAD",0
STRING_BUFSIZE		    db	"BUFSIZE",0
STRING_OBJ		    db	"OBJ",0
STRING_FOLLOWDINO	    db	"FOLLOWDINO",0
STRING_THIRDP		    db	"THIRDP",0
STRING_THIRDPAIM	    db	"THIRDPAIM",0
STRING_OBJN		    db	"OBJN",0
STRING_OBJF		    db	"OBJF",0
STRING_CDINO		    db	"CDINO",0
STRING_GSPD		    db	"GSPD",0

MACRO DEFINE_CHEAT cheat1 {
      dd cheat1
      dd 0
      }

NewCheattableMembers:
	DEFINE_CHEAT	  STRING_MAP
	DEFINE_CHEAT	  STRING_TIME
	DEFINE_CHEAT	  STRING_RESET
	DEFINE_CHEAT	  STRING_DINOINFO
	DEFINE_CHEAT	  STRING_DINOINFOCYCLELEFT
	DEFINE_CHEAT	  STRING_DINOINFOCYCLERIGHT
	DEFINE_CHEAT	  STRING_KILLDINO
	DEFINE_CHEAT	  STRING_MDINO
	DEFINE_CHEAT	  STRING_MSEL
	DEFINE_CHEAT	  STRING_HEALDINO
	DEFINE_CHEAT	  STRING_TESTCHEAT
	DEFINE_CHEAT	  STRING_CLOAK
	DEFINE_CHEAT	  STRING_FAC
	DEFINE_CHEAT	  STRING_FLY
	DEFINE_CHEAT	  STRING_KILLALL
	DEFINE_CHEAT	  STRING_TELEDINO
	DEFINE_CHEAT	  STRING_REC
	DEFINE_CHEAT	  STRING_PLAYERHEALTH
	DEFINE_CHEAT	  STRING_FPS
	DEFINE_CHEAT	  STRING_SUPERHP
	DEFINE_CHEAT	  STRING_NORMALHP
	DEFINE_CHEAT	  STRING_SHOWDD
	DEFINE_CHEAT	  STRING_DRV
	DEFINE_CHEAT	  STRING_LOAD
	DEFINE_CHEAT	  STRING_BUFSIZE
	DEFINE_CHEAT	  STRING_OBJ
	DEFINE_CHEAT	  STRING_FOLLOWDINO
	DEFINE_CHEAT	  STRING_THIRDP
	DEFINE_CHEAT	  STRING_OBJN
	DEFINE_CHEAT	  STRING_OBJF
	DEFINE_CHEAT	  STRING_THIRDPAIM
	DEFINE_CHEAT	  STRING_CDINO
	DEFINE_CHEAT	  STRING_GSPD
EndNewCheattableMembers:

CHEATJUMPINDEX:
	times ((ENDNEWCHEATSINDEX-NEWCHEATSINDEX)+DEFAULT_CHEAT_ENTRY_COUNT*4)	db	0

NEWCHEATSINDEX:
	dd	DISPLAYMAPCONSOLE
	dd	DISPLAYCOUNTER
	dd	RESETCOUNTER
	dd	DISPLAYDINOINFO
	dd	CYCLEDINOINFOLEFT
	dd	CYCLEDINOINFORIGHT
	dd	KILLACTIVEDINO
	dd	SHOWDINOSONMAP
	dd	SHOWACTIVEDINOONMAP
	dd	HEALACTIVEDINO
	dd	TESTCHEATCODE
	dd	CHANGEPLAYERTYPE
	dd	SHOWPLAYERFACEFLOATS
	dd	ENABLEFLYCHEAT
	dd	KILLALLDINOS
	dd	TELEPORTDINOCHEAT
	dd	VIDEOCAPTURETOGGLE
	dd	SHOWPLAYERHEALTH
	dd	TOGGLEFPSDISPLAY
	dd	SETHIGHHPVALUE
	dd	SETNORMALHPVALUE
	dd	SHOWTEMPDRAWDIST_CHEAT
	dd	TOGGLEDRVOBJPOSDISPLAY
	dd	DOLEVELLOADCHEAT
	dd	TOGGLEBUFSIZEDISPLAY
	dd	OBJCHEATTOGGLE
	dd	FOLLOWDINOCHEATTOGGLE
	dd	TOGGLETHIRDPCHEAT
	dd	OBJNCHEATTOGGLE
	dd	OBJFCHEATTOGGLE
	dd	TOGGLETHIRDPAIMCHEAT
	dd	SELECTCLOSESTDINO
	dd	TOGGLEGSPDDISPLAY
ENDNEWCHEATSINDEX:

TotalCheats	dd	0
OriginalCheats	dd	0

;========================================================
;FLY MODE VALUES/VARS
;========================================================

UseFlySpeed		dd	0
UseFlyKeyDelay		dd	0
UseFlyKeyDelay_RECIPR	dd	0

FlySpeedTemp		dd	0
FlySpeedTemp_Fast	dd	0

FLY_MODE_BOOL		db	0
Key_Last_Recorded_Time	dd	0

LastXPostion_FLY	dd	0	;only these need to be updated
LastYPostion_FLY	dd	0	;when cheat is enabled
LastZPostion_FLY	dd	0

Temp_Fly_Buffer 	dd	8 dup 0    ;3 position values, 4 for quats, 1 for bools
Temp_Fly_Buffer2	dd	3 dup 0
Temp_Fly_Buffer3:
	dd 0
	dd 03F800000h
	dd 0

DefaultKeyBOOLS:	;from "KeyMap" reg key/exe key list
	dd	00000040h
	dd	00000080h
	dd	00000010h
	dd	00000008h
	dd	00000020h
	dd	00000001h
	dd	00000002h
	dd	00000100h
	dd	00000400h
	dd	00000200h
	dd	01000000h
	dd	02000000h
	dd	04000000h
	dd	08000000h
	dd	10000000h
DefaultKeyBOOLS_END:

;========================================================
;ACTIONTYPE/DINO JUMP DATA/BUFFERS
;========================================================
AT10_SIM_OBJECT 	db	(64+16) dup 0	  ;VTable set in INI init code include fil

AT10_EMITTER_SIM_OBJECT db	100 dup 0

AT16_SIM_OBJECT 	db	(24h) dup 0
AT18_SIM_OBJECT 	db	(2Ch) dup 0

STRING_GENERAL		db	"General",0
STRING_PUSH		db	"Push",0
STRING_JUMPANGLE	db	"JumpAngle",0
STRING_JUMPTENDANCY	db	"JumpTendancy",0
STRING_REPEATPERIOD	db	"RepeatPeriod",0

;default values
Push_INIdef		db	50 dup 0
JumpAngle_INIdef	db	50 dup 0
JumpTendancy_INIdef	dd	0
RepeatPeriod_INIdef	dd	0

;storage default values
Push_default		db	50 dup 0
JumpAngle_default	db	50 dup 0
JumpTendancy_default	dd	0
RepeatPeriod_default	dd	0

include 'menudata.inc'

;========================================================
GAME_DIFFICULTY_TABLE:		;4 entries per difficulty (very easy, easy, normal, hard, very hard)
	dd	  0.250000	   ;dino health multipliers (+00)
	dd	  0.750000
	dd	  1.000000
	dd	  1.500000
	dd	  2.000000

	dd	  2.000000	   ;player health multipliers (+20)
	dd	  1.300000
	dd	  1.000000
	dd	  0.700000
	dd	  0.400000

;========================================================
;TEMPORARY TEST DATA
;========================================================
Test_Main_BOOL		dd	0

;========================================================
;VIDEO RECORDING
;========================================================

vrdef_bufsize		dd	0	;(vrdef_width*vrdef_height*3) (3 -> 24 bpp)
vrdef_frametime 	dd	0	;(1000 / vrdef_framerate = milliseconds between frames)
vrdef_frametime_INT	dd	0
vrdef_frametimediv1000	dd	0	;vrdef_frametime/1000
vrdef_dibcolors 	dd	0

dibfileheader		DIBDUMPHEADER	;includes error count
VideoStartTime		dd	0
VideoEnabledBool	db	0
NewSaveMethod		dd	0
NoLowFPSComp		dd	FALSE
UseRECWriteThrough	dd	0
newsavemethodSD 	DDSURFACEDESC2	sizeof.DDSURFACEDESC2
dx_temp_memSD		DDSURFACEDESC2	sizeof.DDSURFACEDESC2
dx_temp_mem_RECT	RECT
dx_temp_mem_DDBLTFX	DDBLTFX 	sizeof.DDBLTFX
newsavetempbuffer	dd	0
DXBLT_FIRST_RUN 	db	0

NewSaveMethod_PROCTABLE:
			dd	DoScreenCopyLoop_STD
			dd	DoScreenCopyLoop_MMX
			dd	DoScreenCopyLoop_FPU
			dd	DoScreenCopyLoop_SSE
			dd	DoScreenCopyLoop_SSE2

dibtempfile_handle	dd	0
DIBBitsPointer		dd	0
framerepeatcount_BUF	dd	0
rv_mapview_temp 	dd	0
rv_temp_dc		dd	0
rv_temp_bmp_handle	dd	0
dx_temp_mem_surface	dd	0

rv_encode_success	db	"REC: Saved as "
recvideonamebuf 	db	256 dup 0

VideoElapsedTime_STR	db	"%u sec, %u/%u frames, %u rep",0
VideoDisabled_STR	db	"Video recording disabled",0

rv_no_spec_file 	db	"REC: No valid output file specified",0
rv_error_2		db	"REC E2: Insufficient memory for max frame count",0
rv_error_3		db	"REC E3: Unable to create file mapping object",0
rv_error_4		db	"REC E4: Unable to write frame repeat table",0
rv_error_5		db	"REC E5: Unable to write DIB file header",0
rv_error_6		db	"REC E6: Unable to allocate repeat buffer memory",0
rv_error_7		db	"REC E7: Unable to create DIB dump file",0
rv_error_8		db	"REC E8: Unable to write initial header",0
rv_error_9		db	"REC E9: Unable to allocate frame buffer 2",0
rv_error_A		db	"REC EA: Invalid SaveMethod number",0

rv_error_20		db	"REC E20: CreateCompatibleDC error 0x%.8X ; total: %u",0
rv_error_21		db	"REC E21: CreateDIBSection error 0x%.8X ; total: %u",0
rv_error_22		db	"REC E22: SelectObject error 0x%.8X ; total: %u",0
rv_error_23		db	"REC E23: BitBlt error 0x%.8X ; total: %u",0
rv_error_25		db	"REC E25: WriteFile error 0x%.8X ; total: %u",0
rv_error_26		db	"REC E26: Frame Copy error ; total: %u",0
rv_error_27		db	"REC E27: DDraw Blt error ; total: %u",0
rv_error_28		db	"REC E28: Absent DDraw error 0x%.8X ; total: %u",0
rv_error_29		db	"REC E29: DDSurface create error 0x%.8X ; total: %u",0
rv_error_30		db	"REC E30: DDraw get pixel format error 0x%.8X ; total: %u",0

;MCI audio strings
mci_audio_capt_enabled	dd	0
mci_capt_in_progress	db	0
mcistr_open1		db	"open new type waveaudio alias atxreccapt buffer 4",0
mcistr_set1_str 	db	"set atxreccapt format tag pcm time format ms bitspersample %u "
			db	"channels %u samplespersec %u alignment %u bytespersec %u",0
mcistr_cue1		db	"cue atxreccapt input",0
mcistr_record1		db	"record atxreccapt overwrite",0
mcistr_stop1		db	"stop atxreccapt",0
mcistr_save1		db	"save atxreccapt "
mcistr_savename_buf	db	256 dup 0
mcistr_close1		db	"close atxreccapt",0

mci_bitspersample	dd	0
mci_channelcount	dd	0
mci_samplespersec	dd	0
mci_bytespersec 	dd	0

ValidSaveMethodsTable:
			dd	0
			dd	1
			dd	2
			dd	3
			dd	4
			dd	16
			dd	32
			dd	33
			dd	64
      ValidSaveMethodsTable_END:


;========================================================
;ATXDRV DATA
;========================================================
	align 4
UseATXDRVEscKey 	dd	0
ATXDRV_ENABLED		dd	FALSE
ATXDRV_CURROBJ		dd	0
ATXDRV_CURRENTRTMETHOD	dd	0
ATXDRV_KeyLastTick	dd	0
ATXDRV_KeyTime		dd	0

ATXDRV_CURRVELOCITYBASE dd	0
ATXDRV_INITIALVELOCITY	atxdrv_initial_velocity
ATXDRV_INITVELVECTOR	vector
ATXDRV_INITVELVECTOR_2	vector
ATXDRV_TEMPQUAT 	quaternion
ATXDRV_TEMPQUAT2	quaternion
ATXDRV_CurrentVectorDir dd	3 dup 0
ATXDRV_CurrentVectorVal dd	0
ATXDRV_CurrentVectorVal_Saved	dd	0

ATXDRV_CURRENT		atxdrv_inst_data
ATXDRV_INITIALROTPOS	dd	7 dup 0
ATXDRV_CurrVelocity	dd	0	;front/back only, facing in same direction as object (floats/sec)
ATXDRV_CurrRotSpeed	dd	0	;current rotation speed (radian angles/sec)

ATXDRV_MvtLastTick	dd	0
ATXDRV_MvtTime		dd	0
ATXDRV_KeyPressed	db	0	;bit 0 = mvt key, bit 1 = rot key

;========================================================
;Dinosaur/Vocal
;========================================================

UseNewDinoVocals	dd	0
NewDinoVocalsBuffer	dd	0

;========================================================
;Level load cheat
;========================================================

LevelLoad_INVALID_STR	db	"LOAD: no valid *.scn file specified",0

;========================================================
;LEVELLOADBG
;========================================================

UseNewBackgroundImages	dd	0

;========================================================
;various buffer sizes
;========================================================

UseBUFSIZEInfo		db	0

BUFSIZE_rect		RECT	0,BUFSIZE_MSG,639,479

BUFSIZE_str		db	"Internal buffer sizes (bytes):",0Dh,0Ah
			db	"MAP bmp buffer: %u",0Dh,0Ah
			db	"CAnimal instance info buffer: %u",0Dh,0Ah
			db	"ActJumpNew info buffer: %u",0Dh,0Ah
			db	"New dino vocals buffer: %u",0Dh,0Ah
			db	"MAD buffer: %u"
			db	0
	BUFSIZE_str_end:

BUFSIZE_map_bitmap	dd	0
BUFSIZE_canimal_jump	dd	0
BUFSIZE_newdinovocals	dd	0

;========================================================
;OBJ CHEAT DATA
;========================================================
UseObjCheat		db	0
ObjCheatCurrentObject	dd	0
ObjCheatClassTypeStr	dd	0
ObjCheat_HEX_STR	db	"%X",0
ObjOutput_1_STR 	db	"Object Base Address: 0x%.8X",0
ObjOutput_2_STR 	db	"Velocity: %.5f, %.5f, %.5f",0
ObjOutput_3_STR 	db	"Rotation velocity: %.5f, %.5f, %.5f, %.5f",0
ObjOutput_4_STR 	db	"Location: %.5f, %.5f, %.5f",0
ObjOutput_5_STR 	db	"Orientation (quaternion): %.5f, %.5f, %.5f, %.5f",0
ObjOutput_6_STR 	db	"Orientation (facing/vector): %.5f, %.5f, %.5f",0
ObjOutput_7_STR 	db	"Class/VTable type: %s",0

ObjOutput_Err_STR	db	"OBJ error: invalid object address",0
ObjOutput_Err_2_STR	db	"No valid class type",0

;========================================================
;FOLLOWDINO CHEAT DATA
;========================================================

FD_enabled	       db      0
FD_fetchfunction       dd      0
FD_tickcountinput      dd      0
FD_tickcountcammvt     dd      0
FD_floattimeinput      dd      0
FD_prevcamobj1	       dd      0
FD_prevcamobj2	       dd      0

FD_mousectrlmultiplier dd      0
FD_inputinterval       dd      0       ; 1000 / keyinputrate(persecond)
FD_cammvtinterval      dd      0       ; 1000 / framerate(persecond)
FD_distance	       dd      0       ;distance between object and camera
FD_distanceoriginal    dd      0       ;distance between object and camera
FD_distancespeed       dd      0       ;floats per millisecond
FD_invertmousemul      dd      0

FD_xangle	       dd      0	      ;radians
FD_zangle	       dd      0	      ; negative -> camera pointing downward, positive -> camera pointing upward

FD_zanglemin	       dd      -1.48352986419518014038513715321532    ;radians (85 degrees)
FD_zanglemax	       dd      1.48352986419518014038513715321532

;========================================================
;THIRDP CHEAT
;========================================================

THIRDP_enabled	       db	0
THIRDP_usebaseobject   db	0
THIRDP_prevcamobj1     dd	0
THIRDP_prevcamobj2     dd	0

THIRDP_camtick	       dd	0
THIRDP_inputtick       dd	0
THIRDP_inputtime       dd	0
THIRDP_inputrate       dd	0
THIRDP_camrate	       dd	0

THIRDP_keyliststart:
THIRDP_keyforward      dd	0
THIRDP_keyback	       dd	0
THIRDP_keyreset        dd	0
THIRDP_keyup	       dd	0
THIRDP_keydown	       dd	0
THIRDP_keyaim	       dd	0
THIRDP_keylistend:


THIRDP_distance        dd	0
THIRDP_distanceorig    dd	0
THIRDP_distancespeed   dd	0	  ;floats/millisecond
THIRDP_camspeed        dd	0	  ;radians/millisecond

THIRDP_camanglez       dd	0	  ;(radians)  must be limited to -85 to 85 degrees
THIRDP_camanglezorig   dd	0
THIRDP_camdispz        dd	0

THIRDP_zanglemin       dd	-1.48352986419518014038513715321532    ;radians
THIRDP_zanglemax       dd	1.48352986419518014038513715321532
THIRDP_deathcamrate    dd	1200
THIRDP_deathcamtick    dd	0
THIRDP_playerdeadbool  db	0

;========================================================
;CPARTICLES DATA
;========================================================

CPTypeIDTable	       CParticlesDefault
CPInitialColor	       CParticlesDefault
CPAT109Color	       CParticlesDefault
CPCurrentColor	       CParticlesDefault	;SAVE OF 7 DEFAULT GAME PARTICLE COLORS
						;(allows applying masks without losing values)
CPCurrentColorMax      CParticlesDefault	;format of each: 24-bit color 00RRGGBBh

CPSTR_Blood		db	"Blood",0
CPSTR_Bleed		db	"Bleed",0
CPSTR_Water		db	"Water",0
CPSTR_Terrain		db	"Terrain",0
CPSTR_TerrainSand	db	"Terrain - Sand",0
CPSTR_MetalHard1	db	"Metal Hard 1",0

;========================================================
;AT05 FOG DATA
;========================================================
AT05FOGMAINPROCADDR	dd	0
FogColor_saved		dd	0	     ;NOT NECESSARILY always valid, though assumed to be
					     ;(will not be if level has no AT05 upons CStartTrigger)
FogTempObj		dd	6 dup 0      ;VTable stored at ATYPEX.dll load

AT05FogWithColorModRunOnceInLevel   db	    FALSE


;========================================================
;AT06 RENDERER DATA
;========================================================
AT06RENMAINPROCADDR	dd	0

RenderTempObj		dd	15 dup 0

;========================================================
;AT13 SKY DATA
;========================================================
AT13SKYMAINPROCADDR	dd	0

SkyTempObj		dd	10 dup 0

;========================================================
;NIGHT MODE DATA
;========================================================
;Night level mode is spread across CParticles color change,
;AT05 Fog color change, AT13 Sky fog distances change,
;Global clut default values change, and pre-level load code.

NIGHT_enabled			dd	0
NIGHT_enabled_last		dd	0
NIGHT_FogNearCurrent		dd	0
NIGHT_FogFarCurrent		dd	0
NIGHT_FogColorCurrent		dd	0
NIGHT_CParticlesColorMax	dd	0
NIGHT_CParticlesTypes		dd	0
NIGHT_DefaultGlobalClutStart	dd	0
NIGHT_DefaultGlobalClutStop	dd	0
NIGHT_AmbientLight		dd	0	  ;-1.000000 for not applicable
NIGHT_SkyHeight 		dd	0

;========================================================
;FAST LOAD DISABLE DATA
;========================================================

DisableFastLoad 		dd	FALSE	      ;(constant)
NewGRFLoadDetected		db	TRUE

;========================================================
;ATX 3DNOW OPTIMIZATION-RELATED DATA
;========================================================

UseATX3DNowOpts 		dd	FALSE

;function calls
;first function = std function
;second function = 3DNow! equivalent (null if not implemented)

PTRPROCTABLESTART:

PTRQuaternionMul		   dd	   QuaternionMul_STD
				   dd	   QuaternionMul_3DNOW
PTRToLocalQuat_AxisX		   dd	   ToLocalQuat_AxisX_STD
				   dd	   0
PTRToLocalQuat_AxisY		   dd	   ToLocalQuat_AxisY_STD
				   dd	   0
PTRToLocalQuat_AxisZ		   dd	   ToLocalQuat_AxisZ_STD
				   dd	   0
PTRToLocalQuat_AxisX_NoNorm	   dd	   ToLocalQuat_AxisX_NoNorm_STD
				   dd	   0
PTRToLocalQuat_AxisY_NoNorm	   dd	   ToLocalQuat_AxisY_NoNorm_STD
				   dd	   0
PTRToLocalQuat_AxisZ_NoNorm	   dd	   ToLocalQuat_AxisZ_NoNorm_STD
				   dd	   0
PTRQuatToAxisAngle		   dd	   QuatToAxisAngle_STD
				   dd	   0
PTRNormalizeQuat		   dd	   NormalizeQuat_STD
				   dd	   NormalizeQuat_3DNOW
PTRCONVERT_TO_FACING_PROC_2A	   dd	   CONVERT_TO_FACING_PROC_2A_STD
				   dd	   0
PTRCONVERT_TO_FACING_PROC_010	   dd	   CONVERT_TO_FACING_PROC_010_STD
				   dd	   CONVERT_TO_FACING_PROC_3DNOW_010
PTRVectorDotProduct		   dd	   VectorDotProduct_STD
				   dd	   0
PTRFDConvAnglesToQuat		   dd	   FDConvAnglesToQuat_STD
				   dd	   0
PTRFacingRad2CompToVector_Sub	   dd	   FacingRad2CompToVector_Sub_STD
				   dd	   0
PTRToLocalQuat_NoNorm		   dd	   ToLocalQuat_NoNorm_STD
				   dd	   0
PTRVectorNormalize		   dd	   VectorNormalize_STD
				   dd	   VectorNormalize_3DNOW
PTRQuaternionMulLocalQ2AxisX	   dd	   QuaternionMulLocalQ2AxisX_STD
				   dd	   QuaternionMulLocalQ2AxisX_3DNOW
PTRVectorMagnitude		   dd	   VectorMagnitude_STD
				   dd	   0

PTRPROCTABLEEND:

;========================================================
;AT106 LOAD NEW HINT DATA
;========================================================

HINT_RETURN_ADDR		dd	0
HINT_NEW_STRING_ADDR		dd	0

;========================================================
;OBJN AND OBJF CHEATS DATA
;========================================================

OBJN_instance			dd	0	      ;This should always hold the same instance
						      ;as [ObjCheatCurrentObject], but used under different circumstances
ObjNOutput_Err_STR	 db	 "OBJN error: object does not exist",0

;========================================================
;THIRDPAIM CHEAT
;========================================================
THIRDPAIM_enabled	  db	   0
THIRDAIM_accmultiplier	  dd	   100000000000.000000
THIRDAIM_perspectivemult  dd	   425.000000		  ;256

;========================================================
;MATRIX EFFECT DATA
;========================================================

BIONICWOMAN_enabled		db	0
DisplayGSPD_BOOL		db	0
GameSpeedDisplayString		db	"Game Speed: %.5f",0

AT100SimulatedObject:
				dd	0
				dd	0
DefaultSlowSpeed		dd	0
DefaultInterval 		dd	0
				dd	0
				dd	0
				dd	0
DefaultEnterTransitionInterval	dd	0
DefaultExitTransitionInterval	dd	0

NormalGameSpeed     dd	    0	 ;updated with variable from executable or INI and/or ActionType 100-101
OverrideSVGSpeed    dd	    FALSE
OrigNormalGameSpeed dd	    0

UseMXTBITE		    dd	    0
MXTStateEnabled 	    db	    0
MXTStateInterval	    dd	    0
MXTEnterTransitionInterval  dd	    0
MXTExitTransitionInterval   dd	    0
MXTLastTick		    dd	    0
MXTSlowSpeedCurrent	    dd	    0
MXTSpeedVariationCurrent    dd	    0	   ;[NormalGameSpeed]-[MXTSlowSpeedCurrent]

;========================================================
;QUICKSAVE FUNCTION
;========================================================

FindNextSaveGame_BUF	    db	    512 dup 0
FindNextSaveGame_COUNT_STR  db	    "%.3u",0

QUICKSAVE_tick		    dd	    0
QUICKSAVE_savedone_BOOL     db	    0
QUICKSAVE_levelsave_STR     db	    "LEVEL SAVED",0
	  QUICKSAVE_levelsave_STR_END:

QUICKSAVE_levelsave_err_STR	db	"ERROR SAVING LEVEL",0
	  QUICKSAVE_levelsave_err_STR_END:

QUICKSAVE_filedisplayname_STR	db	"ATX Quick Save",0
	  QUICKSAVE_filedisplayname_STR_END:

QUICKSAVE_currentfilename   db	    50 dup 0	 ;section_gamesaving,key_qscurrentfile

QUICKSAVE_finddatabuf	    FINDDATA

